package com.loafle.overflow.container.general;

import com.loafle.overflow.container.Container;
import com.loafle.overflow.container.configuration.ContainerConfiguration;
import com.loafle.overflow.container.general.server.GeneralContainerConfiguration;
import com.loafle.overflow.container.general.server.GeneralContainerServer;

import org.springframework.context.annotation.AnnotationConfigApplicationContext;

public class GeneralContainer {

  public static void main(String[] args) throws Exception {
    if (args.length <= 0) {
      System.out.println("first parameter is path of pid file");
      return;
    }
    String pidFilePath = args[0];

    try (AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext()) {
      context.getBeanFactory().registerSingleton(Container.PIDFILE_PATH, pidFilePath);
      context.register(ContainerConfiguration.class, GeneralContainerConfiguration.class);
      context.refresh();
      context.registerShutdownHook();
      GeneralContainerServer server = context.getBean(GeneralContainerServer.class);
      server.start();
    }
  }
}
