package com.loafle.overflow.container.general.crawler;

import java.util.HashMap;
import java.util.Map;

import com.loafle.overflow.container.general.crawler.impl.database.mysql.MySQLCrawler;
import com.loafle.overflow.container.general.crawler.impl.database.oracle.OracleCrawler;
import com.loafle.overflow.container.general.crawler.impl.database.postgresql.PostgreSQLCrawler;
import com.loafle.overflow.container.general.crawler.impl.database.sqlserver.SQLServerCrawler;
import com.loafle.overflow.container.general.crawler.impl.jmx.JMXCrawler;
import com.loafle.overflow.container.general.crawler.impl.mongodb.MongoDBCrawler;
import com.loafle.overflow.container.general.crawler.impl.redis.RedisCralwer;
import com.loafle.overflow.container.general.crawler.impl.snmp.SNMPCrawler;
import com.loafle.overflow.container.general.crawler.impl.wmi.WMICrawler;
import com.loafle.overflow.crawler.Crawler;

public abstract class Crawlers {
  private static Map<String, Crawler> crawlers = new HashMap<>();

  static {
    addCrawler(new MySQLCrawler());
    addCrawler(new OracleCrawler());
    addCrawler(new PostgreSQLCrawler());
    addCrawler(new SQLServerCrawler());
    addCrawler(new JMXCrawler());
    addCrawler(new MongoDBCrawler());
    addCrawler(new RedisCralwer());
    addCrawler(new SNMPCrawler());
    addCrawler(new WMICrawler());
  }

  private static void addCrawler(Crawler crawler) {
    String name = crawler.name();
    crawlers.put(name, crawler);
  }

  public static Map<String, Crawler> getCrawlers() {
    return Crawlers.crawlers;
  }

}
