package com.loafle.overflow.container.general.crawler.impl.wmi;

import java.util.HashMap;
import java.util.Map;

import com.loafle.overflow.model.sensorconfig.Item;
import com.loafle.overflow.model.sensorconfig.ResultSet;
import com.loafle.overflow.model.sensorconfig.SensorConfig;

public abstract class WMICrawlerOS {

    private static WMICrawlerOS wmiCrawlerOS = null;

    public static WMICrawlerOS getInstance() {

        if(WMICrawlerOS.wmiCrawlerOS == null) {

            String os = System.getProperty("os.name").toLowerCase();

            if(os.indexOf("linux") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerLinux();
            } else if(os.indexOf("") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerWindows();
            }

        }

        return WMICrawlerOS.wmiCrawlerOS;
    }

    public Map<String, String> process(SensorConfig sensorConfig)  throws Exception {
        Map<String, String> returnMap = new HashMap<String, String>();

        ResultSet ofResultSet = null;
        for(int cIndexI = 0 ; cIndexI < sensorConfig.getItems().size() ; ++cIndexI) {

            ofResultSet = processWMI(sensorConfig, sensorConfig.getItems().get(cIndexI));
            returnMap.putAll(ofResultSet.getData());
        }


        return returnMap;
    }

    public abstract ResultSet processWMI(SensorConfig sensorConfig, Item item) throws Exception ;
}

