package com.loafle.overflow.container.general.server;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.loafle.overflow.container.Container;
import com.loafle.overflow.container.general.crawler.Crawlers;
import com.loafle.overflow.crawler.Crawler;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;

import io.netty.channel.ChannelHandler;

/**
 * GeneralContainerConfiguration
 */
@Configuration
@ComponentScan(basePackages = { "com.loafle.overflow" })
public class GeneralContainerConfiguration {

  @Bean(Container.PIPELINE_CHANNEL_HANDLERS)
  public List<ChannelHandler> pipelineChannelHandlers() {
    return new ArrayList<>();
  }

  @Bean(Container.CRAWLERS)
  public Map<String, Crawler> crawlers() {
    return Crawlers.getCrawlers();
  }

}