package com.loafle.overflow.container.general.crawler.impl.snmp;

import com.google.gson.Gson;
import com.loafle.overflow.container.general.crawler.CrawlerTest;
import com.loafle.overflow.model.sensorconfig.SensorConfig;

import org.junit.Ignore;
import org.junit.Test;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Map;

import static org.junit.Assert.*;

public class SNMPCrawlerTest extends CrawlerTest {
  /***
   * v2c test info
   * private static String addr = "192.168.1.215";
   * private static String port = "161";
   *  private static String community = "public";
   *
   * v3 test info
   * loafle MD5 "qwer5795" DES "qweqwe123" : AUTHPRIV
   * loafle2 SHA "qwer5795" AES "qweqwe123" : AUTHPRIV
   * loafle3 MD5 "qwer5795" : AUTHNOPRIV
   * loafle4 :NOAUTHNOPRIV
   */

  @Ignore
  @Test
  public void testSNMP3() throws Exception {
    SNMPCrawler c = new SNMPCrawler();
    ClassLoader classLoader = getClass().getClassLoader();
    String filePath = classLoader.getResource("config/snmp/examplev3.json").getFile();

    InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(new File(filePath)));

    SensorConfig config = new Gson().fromJson(inputStreamReader, SensorConfig.class);

    Map<String, String> result = c.get(config);

    printResult(result);

  }

  @Ignore
  @Test
  public void testSNMP2c() throws Exception {
    SNMPCrawler c = new SNMPCrawler();

    ClassLoader classLoader = getClass().getClassLoader();
    String filePath = classLoader.getResource("config/snmp/examplev2.json").getFile();

    InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(new File(filePath)));

    SensorConfig config = new Gson().fromJson(inputStreamReader, SensorConfig.class);

    Map<String, String> result = c.get(config);

    printResult(result);
  }

  private void printResult(Map<String, String> resultList) {
    for (Map.Entry<String, String> item : resultList.entrySet()) {
      System.out.println("key=" + item.getKey() + " |||||||||||  value=" + item.getValue());
    }
  }
}