package com.loafle.overflow.container.general.crawler.impl.wmi;

import com.google.gson.Gson;
import com.loafle.overflow.container.general.crawler.CrawlerTest;
import com.loafle.overflow.model.sensorconfig.ResultSet;
import com.loafle.overflow.model.sensorconfig.SensorConfig;

import org.junit.After;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.*;

import static org.junit.Assert.*;

public class WMICrawlerTest extends CrawlerTest {
  @Before
  public void setUp() throws Exception {

  }

  @After
  public void tearDown() throws Exception {

  }

  @Ignore
  @Test
  public void testLinuxExe() throws Exception {

    String command = "/home/snoop/temp/wmic";

    ProcessBuilder builder = new ProcessBuilder(command, "-U", "administrator%dbseogns18", "//192.168.1.106",
        "SELECT Caption FROM Win32_LogicalDisk", "--namespace=root/cimv2", "--delimiter=||");
    Process process = builder.start();

    byte[] msg = new byte[1024];

    StringBuffer buf = new StringBuffer();

    while (process.getInputStream().read(msg) > 0) {
      buf.append(new String(msg));
      Arrays.fill(msg, (byte) 0);
    }

    System.out.println(buf.toString());
  }

  @Ignore
  @Test
  public void testWMI() throws Exception {
    WMICrawler wmiCrawler = new WMICrawler();

    Map<String, Object> map = new HashMap<String, Object>();

    //        String id = "administrator";
    //        String pw = "!@#$qwer1234";
    //        String nameSpace = "root/cimv2";
    //        String query = "select * from Win32_OperatingSystem";
    //        String ip = "192.168.1.1";

    //        map.put("id", "administrator");
    //        map.put("pw", "!@#$qwer1234");
    //        map.put("nameSpace", "root/cimv2");
    //        map.put("query", "select * from Win32_OperatingSystem");
    //        map.put("ip", "192.168.1.1");

    ClassLoader classLoader = getClass().getClassLoader();
    String filePath = classLoader.getResource("config/wmi").getFile();
    System.out.println(filePath);
    InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(new File(filePath)));

    SensorConfig config = new Gson().fromJson(inputStreamReader, SensorConfig.class);

    //        Config c = mapper.readValue(new File(classLoader.getResource("config").getFile()),Config.class);

    //        List<Map<String, String>> resultList =  (List<Map<String, String>>)wmiCrawler.getInternal(map);
    //
    //
    //        for( Map<String,String> rMap : resultList) {
    //            for( String key : rMap.keySet() ){
    //                System.out.println( String.format("key : %s ||| value : %s", key, rMap.get(key)) );
    //            }
    //        }

  }

  @Ignore
  @Test
  public void testOS() {
    System.out.println(System.getProperty("os.name"));

  }

  @Ignore
  @Test
  public void testConfig() throws IOException {
    ClassLoader classLoader = getClass().getClassLoader();
    String filePath = classLoader.getResource("config/wmi/example.json").getFile();
    System.out.println(filePath);
    InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(new File(filePath)));

    SensorConfig config = new Gson().fromJson(inputStreamReader, SensorConfig.class);

    System.out.println(config);
  }

  @Ignore
  @Test
  public void testWMIJson() throws Exception {
    ClassLoader classLoader = getClass().getClassLoader();
    String filePath = classLoader.getResource("config/wmi/meta/meta_network.json").getFile();

    InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(new File(filePath)));
    SensorConfig config = new Gson().fromJson(inputStreamReader, SensorConfig.class);

    //        Map<String, Object> map = new HashMap<>();
    //        map.put("id", "administrator");
    //        map.put("pw", "!@#$qwer1234");

    //        c.getTarget().setAuth(map);

    //        c.getTarget().getAuth().put("id", "administrator");
    //        c.getTarget().getAuth().put("pw", "!@#$qwer1234");

    WMICrawler wmiCrawler = new WMICrawler();

    Map<String, String> resultList = wmiCrawler.get(config);

    PrintResultList(resultList);
    //        for(int indexI = 0 ; indexI < resultList.size(); ++indexI) {
    //            Map<String,String> resultMap = resultList.get(indexI).getData();
    //            System.out.println("============================================");
    //            for( String key : resultMap.keySet() ){
    //                System.out.println( String.format("key : %s ||| value : %s", key, resultMap.get(key)) );
    //            }
    //            System.out.println("============================================");
    //        }

  }

  public void PrintResultList(Map<String, String> m) {
    for (Map.Entry<String, String> item : m.entrySet()) {
      System.out.println("key=" + item.getKey() + " |||||||||||  value=" + item.getValue());
    }
  }

  @Ignore
  @Test
  public void testMetaProcess() throws Exception {

    // get targetinfo
    ClassLoader classLoader = getClass().getClassLoader();
    String filePath = classLoader.getResource("config/wmi/test.json").getFile();

    InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(new File(filePath)));
    SensorConfig config = new Gson().fromJson(inputStreamReader, SensorConfig.class);

    List<SensorConfig> metaConfigList = loadMetaConfig();

    Map<String, String> retlist = new HashMap<>();
    WMICrawlerOS os = WMICrawlerOS.getInstance();
    ResultSet ofResultSet = null;
    for (SensorConfig metaConfig : metaConfigList) {

      for (int indexI = 0; indexI < metaConfig.getItems().size(); ++indexI) {
        ofResultSet = os.processWMI(config, metaConfig.getItems().get(indexI));
        if (ofResultSet != null) {
          retlist.putAll(ofResultSet.getData());
        }
      }
    }

    PrintResultList(retlist);

  }

  public List<SensorConfig> loadMetaConfig() throws IOException {
    ClassLoader classLoader = getClass().getClassLoader();

    URL url = classLoader.getResource("config/wmi/meta");
    if (url == null) {
      return null;
    }

    String path = url.getFile();
    File pathFile = new File(path);

    System.out.println(path);
    String[] metaFiles = pathFile.list();
    List<SensorConfig> retList = new ArrayList<>();

    for (String fi : metaFiles) {
      if (fi.indexOf("meta_") > -1) {
        InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(new File(path + "/" + fi)));
        SensorConfig config = new Gson().fromJson(inputStreamReader, SensorConfig.class);
        if (config != null) {
          retList.add(config);
        }
      }
    }

    return retList;
  }

  @Ignore
  @Test
  public void testInt() {

    Integer a = 1;

    aaa(a);

    System.out.println(a);

  }

  public void aaa(Integer a) {
    ++a;

  }

  @Ignore
  @Test
  public void testString() {

    String str = "cpu[].usage.system";

    int idx = str.indexOf("[");
    int arrIdx = 0;

    String ret = "";
    ret += str.substring(0, idx + 1);
    ret += String.valueOf(arrIdx);
    ret += str.substring(idx + 1);

    System.out.println(ret);

  }

  @Ignore
  @Test
  public void testReplace() {

    String aaa = "cpu[$0].usage.system";

    String bbb = "$";
    String ccc = bbb + String.valueOf(0);

    String ddd = aaa.replace(ccc, "asdfasdf");

    System.out.println(ddd);

  }

  @Ignore
  @Test
  public void testMap() {

    Map<String, String> aa = new HashMap<>();

    aa.put("111", "123123123");
    aa.put("222", "123123123");

    Map<String, String> bb = new HashMap<>();

    bb.put("333", "123123123");
    bb.put("444", "123123123");

    aa.putAll(bb);

    for (String key : aa.keySet()) {
      System.out.println(String.format("key : %s ||| value : %s", key, aa.get(key)));
    }

  }

  @Ignore
  @Test
  public void testRes() throws IOException {
    ClassLoader classLoader = getClass().getClassLoader();

    URL url = classLoader.getResource("config/wmi/meta");

    File file = new File(url.getFile());

    String[] fl = file.list();

    for (String f : fl) {
      System.out.println(f);
    }

  }

}
